﻿using System;
using System.ComponentModel.Composition;
using CardPlay.Model.GameModel;

namespace CardPlay.Client
{
    [Export(typeof(IRandomNumberSequence)), PartCreationPolicy(CreationPolicy.NonShared)]
    public sealed class RandomNumberSequence : IRandomNumberSequence
    {
        private Random _series = new Random();
        private int _seed;

        public int Seed
        {
            get { return _seed; }
            set
            {
                _seed = value;
                Reset();
            }
        }

        public int Next(int maxValue)
        {
            return _series.Next(maxValue);
        }

        public void Reset()
        {
            _series = new Random(Seed);
        }
    }
}