﻿using System.ComponentModel.Composition;

namespace CardPlay.Client.ViewModels
{
    [Export(typeof(GameOverViewModel)), PartCreationPolicy(CreationPolicy.NonShared)]
    public sealed class GameOverViewModel : OptionDialog
    {
        public GameOverViewModel()
        {
            DisplayName = Resources.Caption_GameOver;
            Prompt = Resources.Prompt_GameOver;

            Options.AddRange(new[]
            {
                new CommandViewModel
                {
                    Instruction = Resources.Instruction_EndGame,
                    Action = new RelayCommand<object>(delegate { FireComplete(true); })
                },
                new CommandViewModel
                {
                    Instruction = Resources.Instruction_ReturnAndTryAgain,
                    Description = Resources.Description_ReturnAndTryAgain,
                    Action = new RelayCommand<object>(delegate { FireComplete(false); })
                }
            });
        }
    }
}