﻿using System;
using System.Collections.Generic;
using Caliburn.Micro;
using CardPlay.Client.Tasks;

namespace CardPlay.Client.ViewModels
{
    public class OptionDialog : Screen, IDialog
    {
        private readonly List<CommandViewModel> _options = new List<CommandViewModel>();

        public event EventHandler<DialogResultCompletionEventArgs> Completed;

        public string Prompt { get; set; }

        public List<CommandViewModel> Options { get { return _options; } }

        protected void FireComplete(bool result)
        {
            Completed(this, new DialogResultCompletionEventArgs { DialogResult = result });
        }
    }
}