﻿using CardPlay.Model.CardModel;
using CardPlay.Model.GameModel;
using CardPlay.Model.GameModel.Actions;

namespace CardPlay.DemoPack.Games
{
    [Game("57E1E0A9-8C50-4A68-8F7B-2BC27E9C97E0", LevelOfDifficulty.Easy, LevelOfSkill.MostlyChance, DurationOfPlay.Within5To10Minutes)]
    public class Bridesmaids : Osmosis
    {
        public Bridesmaids()
        {
            MaximumDeals = 3;
            CardsPerDeal = 1;
            TotalTableaus = 0;
        }

        protected override bool IsBuildAllowedOnAdjacentFoundation(MovePileAction action, CardPile precedingFoundation)
        {
            return
                base.IsBuildAllowedOnAdjacentFoundation(action, precedingFoundation) &&
                action.PileBeingMoved.BottomCard.Face.Suit.Color() != precedingFoundation.BottomCard.Face.Suit.Color();
        }
    }
}