﻿using CardPlay.Model.CardModel;
using CardPlay.Model.GameModel;

namespace CardPlay.DemoPack.Games.CanfieldVariants
{
    [Game("8C12BCEF-C0B1-4942-B235-5D6E19DD6BC8", LevelOfDifficulty.Easy, LevelOfSkill.MostlyChance, DurationOfPlay.MoreThan10Minutes, NumberOfDecks = 2, Family = FamilyName)]
    public class AmericanToad : Canfield
    {
        public AmericanToad()
        {
            MaximumDeals = 2;
            CardsPerDeal = 1;

            TotalDecks = 2;
            TotalFoundations = 8;
            TotalTableaus = 8;
        }

        protected override void PrepareDealScript(DealScript script)
        {
            script.DealCardTo(Foundation1);
            script.Deal("20 down,1 up").To(Reserve);
            script.DealCardToEach(NamesOfTableaus);
            script.DealRemainingFaceDownTo(Stock);
        }
    }
}