﻿using CardPlay.Model.CardModel;
using CardPlay.Model.GameModel;

namespace CardPlay.DemoPack.Games.CanfieldVariants
{
    [Game("332C1A09-2675-4BFC-BE66-191B9C0A4BA5", LevelOfDifficulty.Easy, LevelOfSkill.MostlyChance, DurationOfPlay.Within5To10Minutes, Family = FamilyName)]
    public class Chameleon : Canfield
    {
        public Chameleon()
        {
            MaximumDeals = 1;
            CardsPerDeal = 1;

            TotalTableaus = 3;
            TableauBuildSequence = CardFaceSequence.AnySuitDescendingRank;
        }

        protected override void PrepareDealScript(DealScript script)
        {
            script.DealCardTo(Foundation1);
            script.Deal("12 down").To(Reserve);
            script.DealCardToEach(NamesOfTableaus);
            script.DealRemainingFaceDownTo(Stock);
        }
    }
}
