﻿using CardPlay.Model.CardModel;
using CardPlay.Model.GameModel;

namespace CardPlay.DemoPack.Games.CanfieldVariants
{
    [Game("F1FEC96D-47DF-4409-A3DC-2B175D7E381E", LevelOfDifficulty.Easy, LevelOfSkill.ModerateSkill, DurationOfPlay.MoreThan10Minutes, NumberOfDecks = 2, Family = FamilyName)]
    public class DoubleCanfield : Canfield
    {
        public DoubleCanfield()
        {
            TotalDecks = 2;
            TotalFoundations = 8;
            TotalTableaus = 6;
        }

        protected override void PrepareDealScript(DealScript script)
        {
            script.DealCardTo(Foundation1);
            script.Deal("39 down,1 up").To(Reserve);
            script.DealCardToEach(NamesOfTableaus);
            script.DealRemainingFaceDownTo(Stock);
        }
    }
}