﻿using CardPlay.Model.CardModel;
using CardPlay.Model.GameModel;

namespace CardPlay.DemoPack.Games.CanfieldVariants
{
    [Game("E6587AE1-1CFE-42B1-B1C8-35EDF894E113", LevelOfDifficulty.Easy, LevelOfSkill.MostlyChance, DurationOfPlay.Within5To10Minutes, Family = FamilyName)]
    public class Storehouse : Canfield
    {
        public Storehouse()
        {
            MaximumDeals = 3;
            TableauBuildSequence = CardFaceSequence.SameSuitDescendingRank;
        }

        protected override void PrepareDealScript(DealScript script)
        {
            script.DealRankTo(NamesOfFoundations, Rank.Two);
            script.Deal("12 down,1 up").To(Reserve);
            script.DealCardToEach(NamesOfTableaus);
            script.DealRemainingFaceDownTo(Stock);
        }
    }
}