﻿using System.Linq;
using CardPlay.Model.CardModel;
using CardPlay.Model.GameModel;

namespace CardPlay.DemoPack.Games.CongressVariants
{
    [Game("8A862871-446F-4837-A59A-C5544F4BE60A", LevelOfDifficulty.Easy, LevelOfSkill.MostlyChance, DurationOfPlay.Within5To10Minutes, NumberOfDecks = 2, Family = FamilyName)]
    public class GrantsReinforcement : Alhambra
    {
        protected override void PrepareDealScript(DealScript script)
        {
            script.DealAcesTo(StandardPileNames.Foundations.Take(4));
            script.DealRankTo(StandardPileNames.Foundations.Skip(4).Take(4), Rank.King);

            foreach (var pile in PilesNamed("tableau.[1-4]"))
                script.Deal("11 down;1 up").To(pile.Name);

            script.DealRemainingFaceDownTo(Stock);
        }
    }
}