﻿using CardPlay.Model.CardModel;
using CardPlay.Model.GameModel;

namespace CardPlay.DemoPack.Games.FourSeasonsVariants
{
    [Game("962FCFED-2610-4AFE-B4AA-E787DC1F323F", LevelOfDifficulty.Medium, LevelOfSkill.MostlyChance, DurationOfPlay.Within5To10Minutes, Family = FamilyName)]
    public class Corners : FourSeasons
    {
        public Corners()
        {
            MaximumDeals = 3;
            TableauBuildSequence = CardFaceSequence.None;
        }

        protected override void PrepareDealScriptForFoundations(DealScript script)
        {
            script.Deal("(face(hearts) up").To(Foundation1);
            script.Deal("(face(clubs) up").To(Foundation2);
            script.Deal("(face(diamonds) up").To(Foundation3);
            script.Deal("(face(spades) up").To(Foundation4);
        }


        protected override void OnTransactionEnding()
        {
            this.FillFromStockEmptyPilesMatching(AnyTableau);
        }
    }
}