﻿using CardPlay.Model.CardModel;
using CardPlay.Model.GameModel;
using CardPlay.Model.GameModel.Actions;

namespace CardPlay.DemoPack.Games.KlondikeVariants
{
    [Game("F56F49A2-74B2-44DE-BF24-80EC1DB5214A", LevelOfDifficulty.Easy, LevelOfSkill.MostlyChance, DurationOfPlay.Within5To10Minutes, Family = FamilyName)]
    public class BlindAlleys : Klondike
    {
        public BlindAlleys()
        {
            MaximumDeals = 2;
            TotalTableaus = 6;
        }

        protected override void PrepareDealScript(DealScript script)
        {
            script.DealAcesTo(NamesOfFoundations);
            script.DealToEach(NamesOfTableaus, "down;down;up");
            script.DealRemainingFaceDownTo(Stock);
        }

        protected override bool AllowedToBuildEmptyTableau(MovePileAction action)
        {
            return action.PileBeingMoved.BottomCard.Rank != FoundationBaseRank;
        }
    }
}