﻿using CardPlay.Model.CardModel;
using CardPlay.Model.GameModel;
using CardPlay.Model.GameModel.Actions;

namespace CardPlay.DemoPack.Games.KlondikeVariants
{
    [Game("754D755F-F2B8-42A5-8261-4BF5714D57FC", LevelOfDifficulty.Easy, LevelOfSkill.MostlyChance, DurationOfPlay.MoreThan10Minutes, NumberOfDecks = 2, Family = FamilyName)]
    public class Harp : Gargantua
    {
        public Harp()
        {
            MaximumDeals = 3;
        }

        protected override bool AllowedToPickupAtTableau(RemovePileAction action)
        {
            return action.IsActingOnFaceUpTopCard() || (action.PileBeingRemoved.BottomCard.Rank == Rank.King && base.AllowedToPickupAtTableau(action));
        }
    }
}