﻿using CardPlay.Model.CardModel;
using CardPlay.Model.GameModel;
using CardPlay.Model.GameModel.Actions;

namespace CardPlay.DemoPack.Games.KlondikeVariants
{
    [Game("A46A76AC-AE74-42FF-81A5-148163619E18", LevelOfDifficulty.Easy, LevelOfSkill.MostlyChance, DurationOfPlay.Within5To10Minutes, Family = FamilyName)]
    public class ThumbAndPouch : Klondike
    {
        public ThumbAndPouch()
        {
            MaximumDeals = 1;
            TableauBuildSequence = CardFaceSequence.DifferentSuitDescendingRank;
        }

        protected override bool AllowedToBuildEmptyTableau(MovePileAction action)
        {
            return action.PileBeingMoved.BottomCard.Rank != FoundationBaseRank;
        }
    }
}