﻿using CardPlay.Model.GameModel;
using CardPlay.Model.GameModel.Actions;

namespace CardPlay.DemoPack.Games.KlondikeVariants
{
    [Game("75C72301-3CEE-4265-8C08-D153FC5FCD5A", LevelOfDifficulty.Easy, LevelOfSkill.MostlyChance, DurationOfPlay.Within5To10Minutes, Family = FamilyName)]
    public class Westcliff : BlindAlleys
    {
        public Westcliff()
        {
            MaximumDeals = 1;
            TotalTableaus = 10;
        }

        protected override bool AllowedToBuildEmptyTableau(MovePileAction action)
        {
            return base.AllowedToBuildEmptyTableau(action) &&
                (action.IsMovingSingleCard() || action.PileBeingMoved.IsInSequence(TableauBuildSequence));
        }
    }
}