﻿using CardPlay.Model.CardModel;
using CardPlay.Model.GameModel;

namespace CardPlay.DemoPack.Games.PairingVariants
{
    [Game("1C5F2CE6-68D2-4CA2-A23B-854AB5501F18", LevelOfDifficulty.Easy, LevelOfSkill.MostlyChance, DurationOfPlay.Within5To10Minutes, Family = FamilyName)]
    public class Vertical : Nestor
    {
        public Vertical()
        {
            TotalTableaus = 7;
            TotalReserves = 10;
            TotalReserveRows = 2;

            NamesOfAdditionalPiles.Clear();
            NamesOfAdditionalPiles.AddRange(NamesOfReserves);
        }

        protected override IDealAction CreateDealScript()
        {
            var script = new DealScript();

            script.DealToEach(NamesOfReserves, "up");
            script.DealToEach(NamesOfTableaus, "6 up");
            return script.Compile();
        }
    }
}