﻿using CardPlay.Model.GameModel;

namespace CardPlay.DemoPack.Games.PyramidVariants
{
    [Game("3DCD3E7E-9363-4068-A4D5-E00FEB971A8C", LevelOfDifficulty.Easy, LevelOfSkill.MostlyChance, DurationOfPlay.LessThan5Minutes, Family = FamilyName)]
    public class PyramidStones : PyramidEasyCouple
    {
        public override int PercentComplete
        {
            get
            {
                var initialCount = Layout[Reserve].Count;
                var currentCount = this[Reserve].Count;

                return 100 - (100 * currentCount) / initialCount;
            }
        }

        protected override bool IsComplete
        {
            get { return this[Reserve].IsEmpty; }
        }
    }
}