﻿using CardPlay.Model.CardModel;
using CardPlay.Model.GameModel;

namespace CardPlay.DemoPack.Games.SpiderVariants
{
    [Game("CB9FB8EE-7E07-4273-A801-A0A688680C4F", LevelOfDifficulty.Medium, LevelOfSkill.Skill, DurationOfPlay.Within5To10Minutes, NumberOfDecks = 2, Family = FamilyName)]
    public class Spider : Spiderette
    {
        public const string Tableau9 = StandardPileNames.PrefixForTableau + "9";
        public const string Tableau10 = StandardPileNames.PrefixForTableau + "10";
        
        public Spider()
        {
            TotalDecks = 2;
            TotalTableaus = 10;
        }

        protected override IDealAction CreateDealScript()
        {
            var script = new DealScript();

            script.Deal("5 down;up").To(Tableau1);
            script.Deal("5 down;up").To(Tableau2);
            script.Deal("5 down;up").To(Tableau3);
            script.Deal("5 down;up").To(Tableau4);
            script.Deal("4 down;up").To(Tableau5);
            script.Deal("4 down;up").To(Tableau6);
            script.Deal("4 down;up").To(Tableau7);
            script.Deal("4 down;up").To(Tableau8);
            script.Deal("4 down;up").To(Tableau9);
            script.Deal("4 down;up").To(Tableau10);
            script.Deal(";;;;;;;;;;50 down").To(Stock);

            return script.Compile();
        }
    }
}