﻿using System;
using CardPlay.Model.CardModel;
using CardPlay.Model.GameModel;

namespace CardPlay.DemoPack.Games.YukonVariants
{
    [Game("33069EF8-C2BE-4E03-BCE6-76E957D7401A", LevelOfDifficulty.Easy, LevelOfSkill.MostlyChance, DurationOfPlay.LessThan5Minutes, Family = FamilyName)]
    public class AuntMary : Yukon
    {
        public AuntMary()
        {
            NamesOfAdditionalPiles.AddRange(new[] { Stock, Waste });
            MaximumDeals = 1;
            TotalTableaus = 6;
        }

        protected override void PrepareDealScript(DealScript script)
        {
            for (var i = 1; i <= TotalTableaus; ++i)
                script.Deal(String.Format("{0} down;{1} up", i - 1, TotalTableaus - (i - 1))).To(StandardPileNames.PrefixForTableau + i);

            script.DealRemainingFaceDownTo(Stock);
        }
    }
}