﻿using CardPlay.Model.CardModel;
using CardPlay.Model.Primitives;

namespace CardPlay.Model.GameModel.Presentation
{
    public class LayoutMetrics
    {
        public Size CardSize;
        public Size StackingOffsetOnFaceUpCard;
        public Size StackingOffsetOnFaceDownCard;

        public int  MinSpacingAcross;
        public int  MaxSpacingAcross;
        public int  MinSpacingDown;
        public int  MaxSpacingDown;
        
        public Size MaxStackingSize
        {
            get
            {
                return new Size(
                    CardSize.Width + StackingOffsetOnFaceUpCard.Width * CardFace.RanksPerSuit,
                    CardSize.Height + StackingOffsetOnFaceUpCard.Height * CardFace.RanksPerSuit);
            }
        }
    }
}
