﻿
using CardPlay.Model.Primitives;

namespace CardPlay.Model.Layout
{
    public struct MarginSize
    {
        public MarginSize(int size)
        {
            Left = size;
            Top = size;
            Right = size;
            Bottom = size;
        }

        public MarginSize(int l, int t, int r, int b)
        {
            Left = l;
            Top = t;
            Right = r;
            Bottom = b;
        }
    
        public int Left;
        public int Right;
        public int Top;
        public int Bottom;

        public int Width
        {
            get { return Left + Right; }
        }

        public int Height
        {
            get { return Top + Bottom; }
        }

        public Size Size
        {
            get { return new Size(Width, Height); }
        }

        public static MarginSize Empty
        {
            get { return new MarginSize(); }
        }
    }
}