﻿Feature: Card Expressions

Scenario Outline: Comparing Suits
	When I attempt to match the suits <suitA> <suitB> using <match>
	Then the match should be <result> 

	Examples: 
	| match      | suitA  | suitB    | result   |
	| Dont care  | Clubs  | Diamonds | accepted |
	| Same suit  | Spades | Spades   | accepted |
	| Same suit  | Clubs  | Diamonds | rejected |
	| Same color | Clubs  | Diamonds | rejected |
	| Same color | Spades | Clubs    | accepted |
	| Same color | Hearts | Diamonds | accepted |

Scenario Outline: Comparing Ranks
	When I attempt to match the ranks <rankA> <rankB> using <match>
	Then the match should be <result> 

	Examples: 
	| match           | rankA | rankB | result   |
	| Dont care       | Ace   | Queen | accepted |
	| Same rank       | Two   | Three | rejected |
	| Same rank       | Four  | Four  | accepted |
	| Adjacent rank   | Ace   | King  | accepted |
	| Adjacent rank   | Ace   | Two   | accepted |
	| Adjacent rank   | Queen | Jack  | accepted |
	| Adjacent rank   | Queen | Nine  | rejected |
	| Ascending rank  | Three | Four  | accepted |
	| Ascending rank  | Four  | Three | rejected |
	| Ascending rank  | Ten   | Six   | rejected |
	| Ascending rank  | King  | Ace   | accepted |
	| Descending rank | King  | Queen | accepted |
	| Descending rank | Ace   | King  | accepted |
	| Descending rank | King  | Jack  | rejected |


Scenario Outline: Building expressions
	Given the build rule <allow>
	When I attempt to play <card> onto <nextCard>
	Then the play should be <result> 

	Examples:
	| allow                             | card            | nextCard         | result   |
	| None                              | Three of Hearts | Four of Diamonds | rejected |
	| Any suit, any rank                | Three of Hearts | Four of Diamonds | accepted |
	| Different suit, descending rank   | Three of Hearts | Two of Diamonds  | accepted |
	| Different suit, descending rank   | Three of Spades | Two of Spades    | rejected |
	| Same suit                         | Three of Hearts | King of Hearts   | accepted |
	| Any suit, adjacent rank           | Ten of Hearts   | Nine of Diamonds | accepted |
	| Any suit, descending rank         | Five of Spades  | Four of Diamonds | accepted |
	| Same color, descending rank       | Ace of Hearts   | King of Diamonds | accepted |
	| Alternating color, ascending rank | Seven of Clubs  | Eight of Hearts  | accepted |

