﻿Feature: Dealing
	In order to complete the setup of a game
	As a player
	I want to be able to deal cards according to the setup instructions

; Ordering of an unshuffled deck is ranks-within-suits, where suits are ordered: Spades, Hearts, Clubs, Diamonds

Background:
	Given I have a standard unshuffled deck

Scenario: Dealing
	Given I have the following deal instructions:
	| Deal                        | To         |
	| face(red queen) up          | foundation |
	| 3 down;face(clubs seven) up | tableau    |
	| face(diamonds queen) up     | foundation |
	| face(queen) up              | foundation |
	| face(spades) down           | reserve    |
	When I execute the instructions
	Then I should see the cards dealt as follows:
	| Card              | Location   |
	| Queen of Hearts   | foundation |
	| Ace of Spades     | tableau    |
	| Two of Spades     | tableau    |
	| Three of Spades   | tableau    |
	| Queen of Diamonds | foundation |
	| Queen of Spades   | foundation |
	| Four of Spades    | reserve    |
	| Seven of Clubs    | tableau    |

Scenario: Deal remaining
	Given I have stripped the deck to Aces
	And I have the following deal instructions:
	| Deal           | To    |
	| face(clubs) up | stock |
	| remaining down | stock |
	When I execute the instructions
	Then I should see the cards dealt as follows:
	| Card            | Location |
	| Ace of Clubs    | stock    |
	| Ace of Spades   | stock    |
	| Ace of Hearts   | stock    |
	| Ace of Diamonds | stock    |

